## deepin-turbo-0.0.3-2.src.tar.gz

=== src/CMakeLists.txt ===
# Sub build: invoker
add_subdirectory(invoker)

# Sub build: launcher library
add_subdirectory(launcherlib)

# Sub build: generic booster plugin
#add_subdirectory(booster-generic)

# Sub build: Deepin Tool Kit widget booster plugin
add_subdirectory(booster-dtkwidget)

# Sub build: single-instance binary / library
add_subdirectory(single-instance)

=== src/booster-dtkwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

set(LAUNCHER "${CMAKE_HOME_DIRECTORY}/src/launcherlib")
set(COMMON "${CMAKE_HOME_DIRECTORY}/src/common")

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${COMMON} ${LAUNCHER})

# Hide all symbols except the ones explicitly exported in the code (like main())
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
# Create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)
set(CMAKE_SKIP_BUILD_RPATH FALSE)
set(CMAKE_VERBOSE_MAKEFILE ON)

SET(CMAKE_BUILD_RPATH ${CMAKE_BINARY_DIR}/src/launcherlib)

# Find the QtWidgets library
find_package(Qt5Widgets CONFIG REQUIRED)

set(LINK_LIBS
    Qt5::Widgets
    )

# Set sources
set(SRC booster-dtkwidget.cpp)

# Set libraries to be linked.
link_libraries("-L../launcherlib -ldeepin-turbo")

# Set executable
add_executable(booster-dtkwidget ${SRC} ${MOC_SRC})
add_dependencies(booster-dtkwidget deepin-turbo)

target_link_libraries(booster-dtkwidget
    ${LINK_LIBS}
    )

# Add install rule
install(TARGETS booster-dtkwidget DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/deepin-turbo/)
install(FILES deepin-turbo-booster-dtkwidget.service DESTINATION /usr/lib/systemd/user/)

=== src/invoker/CMakeLists.txt ===
set(COMMON "${CMAKE_HOME_DIRECTORY}/src/common")

# Find dbus
include(FindPkgConfig)
pkg_check_modules(DBUS dbus-1 REQUIRED)

# Set sources
set(SRC invokelib.c invoker.c ${COMMON}/report.c search.c)

# Set include dirs
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${DBUS_INCLUDE_DIRS} ${COMMON})

# Set precompiler flags
add_definitions(-DPROG_NAME_INVOKER="deepin-turbo-invoker")

# Set target
add_executable(deepin-turbo-invoker ${SRC})

target_link_libraries(deepin-turbo-invoker ${DBUS_LDFLAGS})

# Add install rule
install(TARGETS deepin-turbo-invoker DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/)

=== src/launcherlib/CMakeLists.txt ===
set(COMMON ${CMAKE_HOME_DIRECTORY}/src/common)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${COMMON})

# Hide all symbols except the ones explicitly exported in the code (like main())
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

# Set sources
set(SRC appdata.cpp booster.cpp connection.cpp daemon.cpp logger.cpp
        singleinstance.cpp socketmanager.cpp)

set(HEADERS appdata.h booster.h connection.h daemon.h logger.h launcherlib.h
    singleinstance.h socketmanager.h ${COMMON}/protocol.h)

# Set libraries to be linked. Shared libraries to be preloaded are not linked in anymore,
# but dlopen():ed and listed in src/launcher/preload.h instead.
link_libraries(${LIBDL} "-L/lib -lsystemd")

# Set executable
add_library(deepin-turbo MODULE ${SRC} ${MOC_SRC})
set_target_properties(deepin-turbo PROPERTIES VERSION 0.1 SOVERSION 0)

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

# Add install rule
install(TARGETS deepin-turbo DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/include/deepin-turbo
  PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=deepin-turbo
pkgver=0.0.3
pkgrel=2
pkgdesc='A daemon that helps to launch applications faster'
arch=('x86_64')
url="https://github.com/linuxdeepin/deepin-turbo"
license=('GPL3')
depends=('qt5-base')
makedepends=('cmake')
groups=('deepin')
source=("$pkgname-$pkgver.tar.gz::https://github.com/linuxdeepin/deepin-turbo/archive/$pkgver.tar.gz")
sha512sums=('c1f62263e259443b29018e704ee4e981feb7023c39d9ce33cb3c68b7834e39ed9f421d250e803aeaa30b56173909609ba99ccbcb1984400c3e11f7705dc6f0af')

build() {
  cd deepin-turbo-$pkgver
  cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_LIBDIR=lib -DCMAKE_BUILD_TYPE=Release .
  make
}

package() {
  cd deepin-turbo-$pkgver
  make DESTDIR="$pkgdir" install
}

=== debian/control ===
Source: deepin-turbo
Section: devel
Priority: extra
Maintainer: Deepin Packages Builder <packages@deepin.com> 
Build-Depends: debhelper (>= 9.0.0),
               cmake,
               pkg-config,
               python,
               libdbus-1-dev,
               dbus,
               libsystemd-dev,
               qtbase5-dev
Standards-Version: 3.9.5

Package: deepin-turbo
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description:  Application launcher for fast startup
 Application invoker and launcher daemon that speed up
 application startup time and share memory. Provides also
 functionality to launch applications as single instances.

Package: deepin-turbo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, deepin-turbo
Description: Development files for launchable applications
  evelopment files for creating applications that can be launched
  using deepin-turbo.

Package: deepin-turbo-booster
Section: devel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, deepin-turbo
Description:  DTK application booster binary for deepin-turbo
